// hwdeint.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "hwdeint.h"

#include "debug.h"

static WCHAR g_wszName[] = L"HW Deinterlace Filter";
CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_HWDeint,
    CHWDeintFilter::CreateInstance,
    NULL,
    NULL
  },
  {
	L"HWDeint Configuration",
    &CLSID_HWDeintProp,
	CHWDeintProp::CreateInstance, 
	NULL,
	NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);


extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

BOOL APIENTRY DllMain( HANDLE hModule,
					   DWORD dwReason,
					   LPVOID lpReserved
					 )
{
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}


// fBA ^Cv錾B
REGPINTYPES sudInputTypes = { &MEDIATYPE_Video, &GUID_NULL };
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &GUID_NULL };


// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         1, &sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};

STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_HWDeint,                // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // DSF JeSB
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_HWDeint);
        pFM2->Release();
    }
    return hr;
}


/* create instance */

CUnknown * WINAPI CHWDeintFilter::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintFilter * pNewObject = new CHWDeintFilter(punk, phr);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}

/* query interfaces */

STDMETHODIMP CHWDeintFilter::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
	CheckPointer(ppv, E_POINTER);

	if (riid == IID_ISpecifyPropertyPages)
	{
        return GetInterface(static_cast<ISpecifyPropertyPages*>(this), ppv); 
	} 
	if (riid == IID_IHWDeint) {
        return GetInterface(static_cast<IHWDeint*>(this), ppv);
    }
	
	return CBaseFilter::NonDelegatingQueryInterface(riid, ppv);
}

/* get property page list */

STDMETHODIMP CHWDeintFilter::GetPages(CAUUID * pPages)
{
	if (pPages == NULL) return E_POINTER;
	pPages->cElems = 1;
	pPages->pElems = (GUID *)CoTaskMemAlloc(pPages->cElems * sizeof(GUID));
	if (pPages->pElems == NULL)
	{
		return E_OUTOFMEMORY;
	}
	pPages->pElems[0] = CLSID_HWDeintProp;

	return S_OK;
}


/* cleanup pages */

STDMETHODIMP CHWDeintFilter::FreePages(CAUUID * pPages)
{
	CoTaskMemFree(pPages->pElems);
	return S_OK;
}


/* constructor */
CHWDeintFilter::CHWDeintFilter(LPUNKNOWN punk, HRESULT *phr)
 : CTransInPlaceFilter2(NAME("HW Deinterlace filter"), punk, CLSID_HWDeint, phr, false)
{
	LoadRegistryInfo();
	ti = new TrayIcon(this);
}

/* destructor */
CHWDeintFilter::~CHWDeintFilter()
{
	SaveRegistryInfo();
	delete ti;
}

/* check input type */

HRESULT CHWDeintFilter::CheckInputType(const CMediaType *mtIn)
{
	
	if (*mtIn->Type() != MEDIATYPE_Video)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	
	if (*mtIn->Subtype() == MEDIASUBTYPE_YUY2 && IsEnable(g_config.colorspace,type_YUY2)){
	} else if (*mtIn->Subtype() == MEDIASUBTYPE_UYVY && IsEnable(g_config.colorspace,type_UYVY)) {
	} else if (*mtIn->Subtype() == MEDIASUBTYPE_YV12 && IsEnable(g_config.colorspace,type_YV12)) {
	} else if (*mtIn->Subtype() == MEDIASUBTYPE_NV12 && IsEnable(g_config.colorspace,type_NV12)) {
	} else if (!g_config.colorspace){
	} else {
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	
	if (*mtIn->FormatType() == FORMAT_VideoInfo)
	{
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
			return S_OK;
	} else if (*mtIn->FormatType() == FORMAT_VideoInfo2) {
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
			return S_OK;
	}

	return VFW_E_TYPE_NOT_ACCEPTED;
}

HRESULT CHWDeintFilter::AddIFlag(CMediaType *pMediaType)
{
	VIDEOINFOHEADER2 *pVih = 
		reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->pbFormat);
	// pVih  VIDEOINFOHEADER o[ɃANZXB 
	if(g_config.interlace){
		if(0 == g_config.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOrWeave;
		}else if(1 == g_config.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOnly;
		}else if(2 == g_config.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeWeaveOnly;
		}
		if(g_config.vif_tff) pVih->dwInterlaceFlags |= AMINTERLACE_Field1First;	
	}

	return S_OK;
}
/* get list of supported output colorspaces */

HRESULT CHWDeintFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{

	if (m_pInput->IsConnected() == FALSE)
	{
		return E_UNEXPECTED;
	}

    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }

    if(iPosition > 0)
    {
        return VFW_S_NO_MORE_ITEMS;
    }

	CheckPointer(pMediaType,E_POINTER);
    *pMediaType = m_pInput->CurrentMediaType();

    if(pMediaType->formattype != FORMAT_VideoInfo && pMediaType->formattype != FORMAT_VideoInfo2)
	{
		return E_UNEXPECTED;
	}

	if(pMediaType->formattype == FORMAT_VideoInfo)
	{
		ConvertVideoInfoToVideoInfo2(pMediaType);
	}

	if (pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		AddIFlag(pMediaType);
	}
	else
	{
		return E_UNEXPECTED;
	}


    return S_OK;
}
    

// dir is the direction of our pin.
// pReceivePin is the pin we are connecting to.
HRESULT CHWDeintFilter::CompleteConnect(PIN_DIRECTION dir,IPin *pReceivePin)
{
    UNREFERENCED_PARAMETER(pReceivePin);
    ASSERT(m_pInput);
    ASSERT(m_pOutput);

    // if we are not part of a graph, then don't indirect the pointer
    // this probably prevents use of the filter without a filtergraph
    if (!m_pGraph) {
        return VFW_E_NOT_IN_GRAPH;
    }

	// do not connect myself
    PIN_INFO ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;

    if (FAILED(pReceivePin->QueryPinInfo(&ReceivePinInfo))) {
		return E_FAIL;
    }
	if (FAILED(ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo))) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	// same filter name
	if(0 == memcmp(g_wszName, ReceiveFilterInfo.achName, sizeof(g_wszName))) {
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);


    // Always reconnect the input to account for buffering changes
    //
    // Because we don't get to suggest a type on ReceiveConnection
    // we need another way of making sure the right type gets used.
    //
    // One way would be to have our EnumMediaTypes return our output
    // connection type first but more deterministic and simple is to
    // call ReconnectEx passing the type we want to reconnect with
    // via the base class ReconeectPin method.
	
    if (dir == PINDIR_OUTPUT) {
		if( m_pInput->IsConnected() ) {
			//return ReconnectPin( m_pInput, &m_pOutput->CurrentMediaType() );
			return ReconnectPin( m_pInput, &m_pInput->CurrentMediaType() );
        }
        return NOERROR;
    }
	
    ASSERT(dir == PINDIR_INPUT);
	

    // Reconnect output if necessary
	/*
    if( m_pOutput->IsConnected() ) {
        if (  m_pInput->CurrentMediaType()
           != m_pOutput->CurrentMediaType() ) {
			return ReconnectPin( m_pOutput, &m_pInput->CurrentMediaType() );
			}
	}*/

    return NOERROR;

} // ComnpleteConnect


// transform
HRESULT CHWDeintFilter::Transform(IMediaSample *pDest)
{
  
  if(g_config.use_imedia2 && g_config.interlace){
    // Obtain IMediaSample2 interface and fill structure with interlace information.
    IMediaSample2 *pOut2 = NULL;
    AM_SAMPLE2_PROPERTIES outProp2;
    
    if (FAILED(pDest->QueryInterface(IID_IMediaSample2, (void **)&pOut2))){
      DPRINTF("QueryInterface");  
    }else if (SUCCEEDED(pOut2->GetProperties(FIELD_OFFSET(AM_SAMPLE2_PROPERTIES, tStart), (PBYTE)&outProp2))){
      // Set interlace information (every sample)
      outProp2.dwTypeSpecificFlags = AM_VIDEO_FLAG_INTERLEAVED_FRAME;

      if (g_config.weave)outProp2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_WEAVE;
	  if (g_config.am2_tff)outProp2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_FIELD1FIRST;
      pOut2->SetProperties(FIELD_OFFSET(AM_SAMPLE2_PROPERTIES, dwStreamId), (PBYTE)&outProp2);
      pOut2->Release();
    }else{
      DPRINTF("GET_PROP2");
    }
  }                            

  return S_OK;
}

