#ifndef _HWDEINT_H_
#define _HWDEINT_H_

#include "hwdeintprop.h"
#include "transip2.h"
#include "tray.h"

// transip2

class CHWDeintFilter : public CTransInPlaceFilter2, public IHWDeint, public ISpecifyPropertyPages
{

public:

    static CUnknown *WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void ** ppv);
	DECLARE_IUNKNOWN;

	CHWDeintFilter(LPUNKNOWN punk, HRESULT *phr);
	~CHWDeintFilter();

	HRESULT CheckInputType(const CMediaType * mtIn);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	
	HRESULT Transform(IMediaSample *pDest);

	HRESULT CompleteConnect(PIN_DIRECTION dir,IPin *pReceivePin);

	STDMETHODIMP GetPages(CAUUID * pPages);
	STDMETHODIMP FreePages(CAUUID * pPages);
	STDMETHODIMP hide_tray(void){
		CAutoLock lock(&m_csShared);
		ti->hide();
		return S_OK;
	}
	STDMETHODIMP show_tray(void){
		CAutoLock lock(&m_csShared);
		ti->show();
		return S_OK;
	}

private:
	CCritSec  m_csShared;
	HRESULT AddIFlag(CMediaType *pMediaType);
	TrayIcon *ti;
	
};


#endif  /* _HWDEINT_H_ */
