#include "stdafx.h" 

#include "hwdeintprop.h"
#include "tray.h"
#include "hwdeint.h"
#include "resource.h"

#define TRAYICON 3002
#define MSG_TRAYICON (WM_APP+15)

/* global */
extern CONFIG g_config;

static LRESULT CALLBACK trayWndProc (HWND hwnd, UINT msg, WPARAM wprm, LPARAM lprm)
{
	TrayIcon *ti=(TrayIcon*)GetWindowLong(hwnd,GWL_USERDATA);
	if(msg == MSG_TRAYICON){
		if(!ti) return 0;
		switch (lprm)
		{
		case WM_LBUTTONDBLCLK:
			ti->show_prop(hwnd);
			return 0;

        case WM_RBUTTONUP:
		case WM_CONTEXTMENU:
			POINT p;
			GetCursorPos(&p);
			if(!g_config.interlace){
				EnableMenuItem(ti->hMenu, IDM_IMEDIA2, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
			}else{
				EnableMenuItem(ti->hMenu, IDM_IMEDIA2, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}
			if(g_config.use_imedia2){
				CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_CHECKED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}else{
				CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_UNCHECKED);
				EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
				EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
			}
			CheckMenuItem(ti->hMenu, IDM_FIELD1FIRST, g_config.am2_tff ?MF_CHECKED:MF_UNCHECKED);
			CheckMenuItem(ti->hMenu, IDM_WEAVE, g_config.weave ? MF_CHECKED:MF_UNCHECKED);
			SetForegroundWindow(hwnd);
			TrackPopupMenu(ti->hMenu,TPM_RIGHTALIGN|TPM_BOTTOMALIGN,p.x,p.y,0,hwnd,NULL);
			return 0;
		}
	} else if(msg == WM_COMMAND) {//if(msg==MSG_TRAYICON)
		if(!ti) return 0;
		switch (LOWORD(wprm))
		{
		case IDM_SHOWPROP:
			ti->show_prop(hwnd);
			return 0;
		case IDM_IMEDIA2:
			g_config.use_imedia2 = !g_config.use_imedia2;
			break;
		case IDM_FIELD1FIRST:
			g_config.am2_tff = !g_config.am2_tff;
			break;
		case IDM_WEAVE:
			g_config.weave = !g_config.weave;		
			break;
		}
		if(g_config.use_imedia2){
			CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_CHECKED);
			EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_ENABLED);
			EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_ENABLED);
		}else{
			CheckMenuItem(ti->hMenu, IDM_IMEDIA2, MF_UNCHECKED);
			EnableMenuItem(ti->hMenu, IDM_FIELD1FIRST, MF_GRAYED);
			EnableMenuItem(ti->hMenu, IDM_WEAVE, MF_GRAYED);
		}
		CheckMenuItem(ti->hMenu, IDM_FIELD1FIRST, g_config.am2_tff ?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(ti->hMenu, IDM_WEAVE, g_config.weave ? MF_CHECKED:MF_UNCHECKED);
		return 0;
	}
	return DefWindowProc(hwnd,msg,wprm,lprm);
}

TrayIcon::TrayIcon(CHWDeintFilter *Chwdf):hwdf(Chwdf)
{
 WNDCLASS wndclass ;
 wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
 wndclass.lpfnWndProc   = trayWndProc ;
 wndclass.cbClsExtra    = 0 ;
 wndclass.cbWndExtra    = 0 ;
 wndclass.hInstance     = hi = g_hInst;
 wndclass.hIcon         = NULL;
 wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW) ;
 wndclass.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
 wndclass.lpszMenuName  = NULL ;
 wndclass.lpszClassName = "hwdeint";
 ha=RegisterClass(&wndclass);
 
 h=CreateWindow(
                "hwdeint",                   // window class name
                TEXT("hwdeint"),            // window caption
                WS_OVERLAPPED|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,
                CW_USEDEFAULT,              // initial x position
                CW_USEDEFAULT,              // initial y position
                1,                          // initial x size
                1,                          // initial y size
                NULL,                       // parent window handle
                NULL,                       // window menu handle
                hi,                         // program instance handle
                NULL
               );                     
 SetWindowLong(h,GWL_USERDATA,LONG(this));
 nid.cbSize=sizeof(nid);
 nid.hWnd=h;
 nid.uID=TRAYICON;
 nid.uFlags=NIF_ICON|NIF_TIP|NIF_MESSAGE;
 nid.hIcon=LoadIcon(hi,MAKEINTRESOURCE(IDI_HWICON));
 nid.uCallbackMessage=MSG_TRAYICON;
 strcpy(nid.szTip,"hwdeint");

 
 hMenu = LoadMenu(hi, MAKEINTRESOURCE(IDR_HWDMENU));
 hMenu = GetSubMenu(hMenu, 0);

 visible = g_config.tray;
 if(visible){
	 Shell_NotifyIcon(NIM_ADD,&nid);
 }
}

TrayIcon::~TrayIcon()
{
 Shell_NotifyIcon(NIM_DELETE,&nid);
 DestroyWindow(h);
 UnregisterClass("hwdeint",hi);
}

void TrayIcon::show(void)
{
 if (!visible)
  {
   Shell_NotifyIcon(NIM_ADD,&nid);
   visible=true;
  }; 
}

void TrayIcon::hide(void)
{
 if (visible)
  {
   Shell_NotifyIcon(NIM_DELETE,&nid);
   visible=false;
  }; 
}

void TrayIcon::show_prop(HWND hwnd){
	CBaseFilter *pFilter = hwdf;
	ISpecifyPropertyPages *pProp;
	HRESULT hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
	if (SUCCEEDED(hr)) 
	{
		// tB^̖O IUnknown |C^擾B
		FILTER_INFO FilterInfo;
		hr = pFilter->QueryFilterInfo(&FilterInfo); 
		IUnknown *pFilterUnk;
		pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);

		// y[W\B
		CAUUID caGUID;
		pProp->GetPages(&caGUID);
		pProp->Release();
		OleCreatePropertyFrame(
			hwnd,                   // eEBhEB
			0, 0,                   // \ς݁B
			FilterInfo.achName,     // _CAO {bNX̃LvVB
			1,                      // IuWFNg (tB^̂)B
			&pFilterUnk,            // IuWFNg |C^̔zB
			caGUID.cElems,          // vpeB y[WB
			caGUID.pElems,          // vpeB y[W CLSID ̔zB
			0,                      // P[ʎqB
			0, NULL                 // \ς݁B
		);

		// N[ AbvB
		pFilterUnk->Release();
		FilterInfo.pGraph->Release(); 
		CoTaskMemFree(caGUID.pElems);
	}
}

